#include <err.h>
#include <stdlib.h>
#include <stdio.h>
#include "util.h"

size_t
allocarr(double **arr, const char *str, size_t maxlen)
{
	size_t i, nf = 0;

	if (maxlen > 0)
		nf = 1;
	for (i = 0; i < maxlen && str[i] != '\0'; i++)
		if (str[i] == DELIM)
			nf++;
	if (!(*arr = calloc(nf, sizeof(double))))
		err(1, "calloc");

	return nf;
}

int
scannextval(char **str, double *val)
{
	int offset;

	if (sscanf(*str, "%lg%n", val, &offset) != 1)
		return 0;
	*str += offset;

	return 1;
}

void
printarr(double *arr, size_t len)
{
	size_t i;

	for (i = 0; i < len; i++) {
		printf("%g", arr[i]);
		if (i < len)
			printf(DELIMSTR);
	}
	puts("");
}
